#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2two9004xi.py">
#<abstract4xi abstract = "fires to direction two and to distance 900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2two9004xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2TWO - COORDINATE SIGNS OF SHOOT2TWO4XI: (X + ,Y - ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2two9004xi

#"
#/>

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

# -------------------------------------------------------------------------------------------------
# 900
# -------------------------------------------------------------------------------------------------
shot2two9004xi = {
        1:'105x-443y-775z',
        2:'116x-371y-921z',
        3:'11x-486y-757z',
        4:'122x-558y-695z',
        5:'125x-890y-45z',
        6:'126x-430y-780z',
        7:'145x-415y-784z',
        8:'149x-544y-700z',
        9:'164x-400y-789z',
        10:'16x-390y-810z',
        11:'171x-881y-54z',
        12:'175x-529y-706z',
        13:'181x-383y-793z',
        14:'197x-366y-797z',
        15:'200x-512y-712z',
        16:'212x-349y-801z',
        17:'217x-870y-63z',
        18:'223x-494y-717z',
        19:'226x-330y-805z',
        20:'238x-312y-809z',
        21:'246x-476y-722z',
        22:'248x-293y-813z',
        23:'249x-7y-864z',
        24:'257x-21y-862z',
        25:'258x-273y-817z',
        26:'262x-857y-72z',
        27:'264x-35y-859z',
        28:'266x-254y-821z',
        29:'267x-456y-728z',
        30:'271x-51y-856z',
        31:'273x-234y-824z',
        32:'276x-67y-853z',
        33:'278x-214y-828z',
        34:'280x-83y-851z',
        35:'282x-195y-831z',
        36:'283x-101y-848z',
        37:'285x-119y-844z',
        38:'285x-175y-835z',
        39:'286x-137y-841z',
        40:'286x-156y-838z',
        41:'286x-435y-733z',
        42:'304x-414y-738z',
        43:'306x-842y-81z',
        44:'31x-899y-27z',
        45:'321x-391y-743z',
        46:'336x-369y-748z',
        47:'349x-345y-753z',
        48:'34x-591y-677z',
        49:'350x-824y-90z',
        50:'35x-381y-814z',
        51:'361x-321y-758z',
        52:'36x-477y-761z',
        53:'372x-297y-763z',
        54:'380x-273y-768z',
        55:'381x-17y-815z',
        56:'387x-38y-811z',
        57:'388x-248y-772z',
        58:'392x-803y-99z',
        59:'393x-224y-777z',
        60:'393x-59y-807z',
        61:'397x-82y-803z',
        62:'398x-200y-781z',
        63:'3x-598y-671z',
        64:'400x-104y-799z',
        65:'400x-175y-786z',
        66:'402x-128y-794z',
        67:'402x-151y-790z',
        68:'422x-794y0z',
        69:'433x-781y-108z',
        70:'463x-771y-8z',
        71:'473x-756y-117z',
        72:'503x-745y-17z',
        73:'511x-729y-126z',
        74:'541x-718y-26z',
        75:'548x-700y-135z',
        76:'54x-370y-818z',
        77:'578x-688y-35z',
        78:'583x-670y-144z',
        79:'60x-467y-766z',
        80:'613x-657y-44z',
        81:'616x-637y-153z',
        82:'646x-624y-53z',
        83:'647x-603y-162z',
        84:'64x-581y-683z',
        85:'677x-567y-170z',
        86:'677x-589y-62z',
        87:'704x-530y-179z',
        88:'706x-552y-71z',
        89:'729x-491y-188z',
        90:'72x-359y-821z',
        91:'734x-514y-80z',
        92:'752x-451y-197z',
        93:'759x-474y-89z',
        94:'773x-410y-206z',
        95:'782x-433y-98z',
        96:'78x-895y-36z',
        97:'792x-368y-214z',
        98:'803x-391y-107z',
        99:'808x-326y-223z',
        100:'821x-348y-116z',
        101:'822x-282y-232z',
        102:'833x-238y-240z',
        103:'837x-304y-125z',
        104:'83x-456y-771z',
        105:'842x-194y-249z',
        106:'849x-149y-258z',
        107:'851x-260y-133z',
        108:'853x-104y-266z',
        109:'853x-14y-284z',
        110:'854x-59y-275z',
        111:'862x-214y-142z',
        112:'869x-232y-2z',
        113:'870x-169y-151z',
        114:'876x-123y-160z',
        115:'880x-187y-11z',
        116:'880x-77y-169z',
        117:'881x-30y-178z',
        118:'888x-140y-20z',
        119:'894x-94y-29z',
        120:'897x-47y-38z',
        121:'89x-347y-825z',
        122:'93x-570y-689z'}                         
        
#"
#"/>

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire900two4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire900two4xi(queue2two, consumer_channel2two, publisher_channel2two):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE900TWO4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE900TWO4XI -  QUEUE2TWO: ", queue2two)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE900TWO4XI -  CONSUMER_CHANNEL2TWO: ", consumer_channel2two)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE900TWO4XI -  PUBLISHER_CHANNEL2TWO: ", publisher_channel2two)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE900TWO4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2two.put(shot2two9004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE900TWO4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE900TWO4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE900TWO4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2two8shot2two9004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2two8shot2two9004xi</nack2put4xi>" 
            
        publisher_channel2two.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE900TWO4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE900TWO4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE900TWO4XI - RETURNING QUEUE OBJECT QUEUE2TWO: ", queue2two, " - TIME: ", time4xi())  
        # 
            
    return queue2two    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verbkb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2two9004xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
